c     LECONS  is a program for learning foreign language word lists
c
c     Copyright (C) 2001  Boud Roukema  boud1@wp.pl
c
c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2 of the License, or
c     (at your option) any later version.
c
c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.
c
c     You can see a full copy of this license (GPL) at http://www.gnu.org .
c      
c     Veuillez lire la version entire du licence (LPG) au site
c     http://www.april.org
c
c
c     To compile:
c      use the makefile
c
c      make lecons
c
c
c     Usage: 
c
c      lecons <filename> [random number optional ["pc" optional for small screen]]
c      
c
c      lecons 981008lecon.txt
c
c      or
c      
c      lecons 981008lecon.txt 12345
c
c      or
c
c      lecons 981008lecon.txt 12345 pc
c
c
c
      program lecons
C     ==== Pour pratiquer des lecons du franais, polonais etc. ====
C     $ imprimer liste des scores
C     # rvaluer un score

      parameter(maxjour=1,maxent=300)

      real*4         val(maxjour,maxent) ! mauvaise ordre - faut la changer!
      real*4         sco(maxent,maxjour) 
      real*4         ei(maxent)
      real*4         snorm(maxent) ! score normalis pour la figure
      parameter(maxch=130) ! => character*maxch dans la ligne suivante :
      character*130  qn(maxjour,maxent),ligne,nul! mauvaise ordre !
      parameter(maxcrep=120)
      character*120   rep(maxjour,maxent),essai! mauvaise ordre - faut la changer!
      integer*4      ne(maxjour)

      character*256  instring,liste
c      character*19  ch19
      logical*1     prfois

      character*2    sm
      logical*1      dosm

C     parameters for swapping bytes in case score file used by other machine
      logical*1      swapbyte
      parameter(mxbyte=376)
      byte           bytearray(mxbyte)
c      character*8192 chararray
      integer*4      intarray(mxbyte/4)
      real*4         realarray(mxbyte/4)
      
      equivalence(chararray,bytearray(1),intarray(1),realarray(1))

      swapbyte=.false. !.true.
C     --- hardwired method: need  mxbyte = exact no of bytes in file,
C     rounded down to nearest multiple of four ----
      
      nul= '                                        '
     _     //'                                        '

c     --- copyright introduction ---

      print*,'GNU GENERAL PUBLIC LICENSE'
      print*,'This program is free software; you can redistribute'
      print*,'it and/or modify it under the terms of the GNU'
      print*,'General Public License as published by the Free'
      print*,'Software Foundation; either version 2 of the'
      print*,'License, or (at your option) any later version.'
      print*,' '
      print*,'This program is distributed in the hope that it'
      print*,'will be useful, but WITHOUT ANY WARRANTY; without'
      print*,'even the implied warranty of MERCHANTABILITY or'
      print*,'FITNESS FOR A PARTICULAR PURPOSE.  See the GNU'
      print*,'General Public License for more details.'
      print*,' '
      print*,'You can see a full copy of this license (GPL) at'
      print*,'http://www.gnu.org .'
      print*,' '
      print*,'Veuillez lire la version entire du licence (LPG)'
      print*,'au site http://www.april.org'
      print*,' '
      call mypause
      print*,'COMPILING'
      print*,'To compile:'
      print*,' use the makefile'
      print*,' '
      print*,' make lecons'
      print*,' '
      print*,' '
      call mypause
      print*,'USING'
      print*,'Usage: '
      print*,' lecons <filename> [random number ["sm"]]'
      print*,'- the initial random number is optional '
      print*,'- if the random number is present, then a character'
      print*,'string "sm" (without the quotation marks) can be'
      print*,'used to get a smaller box'
      print*,' '
      print*,' '
      print*,'Example usage:'
      print*,' lecons 981008lecon.txt'
      print*,' '
      print*,' or'
      print*,' '
      print*,' lecons 981008lecon.txt 12345'
      print*,' '
      print*,' or'
      print*,' '
      print*,' lecons 981008lecon.txt 12345 pc'
      print*,' '
      call mypause
      print*,'INPUT FILE'
      print*,'The input file can be made with any text editor. '
      print*,'There should be successive sets of three lines,'
      print*,'each starting with a '
      print*,'four-character keyword ="VAL ", "QN  " or "REP ",'
      print*,'in that order - there may be comment lines between'
      print*,'sets of three keyword lines. '
      print*,'Example'
      print*,'VAL 3'
      print*,'QN  language'
      print*,'REP je,zyk'
      print*,' '
      print*,'MORE HINTS'
      print*,'Try http://darc3.obspm.fr/~roukema/lang/ for '
      print*,'more hints'
      print*,' '
      call mypause

c
c     getarg is a g77 compatible subroutine which reads information
c     from the command line following the call to the executable programme.
c     
c     For example, if you type
c
c     lecons 981008lecon.txt 12345 sm
c     
c     then  call getarg(1,instring) will put the string "981008lecon.txt"
c     into the character*256 variable called  instring.
c

      print*,'Commenc,ons la lec,on... :-) '

c     ---- first command line argument: 
c     the name of the file containing the vocabulary ----
       call getarg(1,instring)
       read(instring,'(a)')liste

c     ---- 2nd command line argument (optional) a "random" seed (optional) ----
       call getarg(2,instring)
       nflush= 123456
       read(instring,*,end=222,err=222)nflush
 222   continue 
       print*,'nflush=',nflush

c     ---- 3rd command line argument (optional, but must be the 3rd argument) 
c     an option for a smaller box size for the pgplot box ----
       call getarg(3,instring)
       read(instring,'(a)',end=333,err=333)sm
 333   continue
       dosm=.false.
       if(sm.eq.'sm')dosm=.true.

c       print*,'Have read args'

c     ---- initialisation ----
      open(1,file=liste,access='sequential',status='old',
     _     form='formatted')
      ligne='DEBUT'
      ij=1
      ie=0
      read(1,'(a)',end=666)ligne
      do while(ligne(1:3).ne.'FIN')
         if(ligne(1:3).eq.'VAL')then
            ie=ie+1
            
c            print*,'ligne=',ligne
c            print*,'ligne(4:5)=',ligne(4:5)

c     --- dec version --
c            read(ligne(4:5),'(i2)',end=666)ii
c            val(ij,ie)=real(ii)
c     --- sun version --
            read(ligne(4:maxch),*,end=666)val(ij,ie)

c            print*,'val(ij,ie)=',val(ij,ie)

            read(1,'(a)',end=666)ligne
            if(ligne(1:3).ne.'QN ')then
               print*,'ATTENTION: QN ligne=',ligne
            endif
            qn(ij,ie)=ligne(5:maxch)

            ligne=nul
            read(1,'(a)',end=666)ligne
            if(ligne(1:3).ne.'REP')then
               print*,'ATTENTION: REP ligne=',ligne
            endif
            ioff=4
            rep(ij,ie)=ligne(1+ioff:maxch)//'             '
c            print*,'rep(ij,ie)=',rep(ij,ie)
         endif
         read(1,'(a)',end=666)ligne
      enddo
 666  continue
      ne(ij)=ie
      print*,'ij, Nombre de questions = ',ij, ne(ij)

      nj=ij
      close(1)


c     ---- anciens scores (difaults) ----
      do ij=1,nj
         do ie=1,ne(ij)
            sco(ie,ij)= val(ij,ie)
         enddo
      enddo
      
c     ---- anciens scores (anciens) ----
c     ---- old scores ----
c     ---- micro$oft WARNING - may be a problem with filename lengths
c     if the user uses names which are too long ----

      nj2=0
      if(.not.(swapbyte))then
         open(1,file='s0'//liste,access='sequential',status='old',
     _        form='unformatted',err=777)
         read(1,end=777,err=777)
     _        nj2,(ne2,(sco(ie,ij),ie=1,ne2),ij=1,nj2)
      else
         open(1,file='s0'//liste,access='direct',status='old',
     _        err=777,recl=mxbyte)
         read(1,rec=1)intarray

         print*,'swapping bytes in read-in score file...'
         do i=1,mxbyte/4
            jj= iswbyte(intarray(i))
            intarray(i)=jj
         enddo


         nj2= intarray(2)       ! 1st byte is number of bytes in file !
         print*,' !!!!! nj2=',nj2
         jjtot=2
         do ij=1,nj2
            ne2= intarray(jjtot+1)
            do ie=1,ne2
               sco(ie,ij)= realarray(jjtot+1+ie)
            enddo
            jjtot=jjtot+1+ne2
         enddo

c     read(1,err=777)
c     _     nj2,(ne2,(sco(ie,ij),ie=1,ne2),ij=1,nj2)
      endif
            
c     ---- copie de l'ancien fichier ----
      open(2,file='s1'//liste,
     _     access='sequential',status='unknown',
     _     form='unformatted')
      write(2)
     _     nj,(ne(ij),(sco(ie,ij),ie=1,ne(ij)),ij=1,nj)
      close(2)
c     ---

 777  continue
      close(1)

      if(nj2.eq.0)then
         print*,'Pas de scores anciens. '
      endif
      print*,' '

c     ---- combinaison  valeurs + scores ----
      do ij=1,nj
         do ie=1,ne(ij)
            if(sco(ie,ij).lt.1.0e-4)then !soit nouveau QN, soit QN basse prob.
               sco(ie,ij)= val(ij,ie) 
            elseif(sco(ie,ij).lt.1.0)then
            endif
         enddo
      enddo

c     ---- lecons ----
      ij=1

c      call itime(i1,i2,i3)

c      i1=itime
c      print*,'i1,i2,i3=',i1,i2,i3
c      n=10000*i1+100*i2+i3
      n=nflush
      iseed=mod(nflush*3433,3449) ! nice big seed :)
      do i=1,n
         x=ran4(iseed)
      enddo
      
      sco0=0.0
      val0=0.0
      do ij=1,nj
         do ie=1,ne(ij)
            sco0= sco0+ sco(ie,ij)
            val0= val0+ val(ij,ie)
            ei(ie)=real(ie)
         enddo
      enddo
      print*,'sco0,val0=',sco0,val0

      xmin=0.0
      xmax=real(ne(nj)+1)
      ymin=0.0
      ymax=1.1

      write(6,'(a,$)')'Indices (2) de couleur (pgdemo2 pour voir)? '
      read(5,*)icol1,icol2

c     ==== extension 08/09/02 BEGIN
      write(6,'(a,$)')'Indice de couleur de fond (pgdemo2 pour voir)? '
      read(5,*)icolfond
c     ==== extension 08/09/02 END


      call pgbegin(0,'?',1,1)
c     ==== extension 08/09/02 BEGIN
      if(.not.(dosm))then
         call pgvsize(0.0,9.0,0.0,7.0)
      else
         call pgvsize(0.5,5.5,0.5,3.59)
      endif
      call pgwindow(0.0,1.0,0.0,1.0)
      call pgqfs(ioldfs)
      call pgqci(ioldci)

      call pgsfs(1) ! set fill style solid colour
      call pgsci(icolfond)
      call pgrect(0.0,1.0,0.0,1.0)

      call pgsfs(ioldfs) ! reset previous fs
      call pgsci(ioldci) ! reset previous ci

c     ==== extension 08/09/02 END

      if(.not.(dosm))then
         call pgvsize(1.0,8.0,1.0,5.33)
      else
         call pgvsize(1.0,5.0,1.0,3.09)
      endif
      call pgwindow(xmin,xmax,ymin,ymax)

c      symch= (real(ne(ij))/30.0) *2.0 
      symch= 2.0 !*40.0/real(ne(ij))

      call pgsch(1.8)
c     ==== extension 08/09/02 BEGIN
      call pgsci(icol1) ! for lines
c     ==== extension 08/09/02 END

      call pgbox('bcnts',0.,0,'bc',0.,0)
      call pglabel('mots','score',' ')

      do while(1+1.eq.2)
         scotot=0.0
         do ij=1,nj
            do ie=1,ne(ij)
               scotot= scotot+ sco(ie,ij)
            enddo
         enddo
c         print*,'scotot=',scotot
         print*,scotot

         xran= ran4(nflush)* scotot 
         x= 0.0
         ij=nj                  ! uniquement "jour" final
         ie=0
c         print*,'x,xran,ie=',x,xran,ie
         do while(x.lt.xran.and. ie.lt.ne(ij))
            ie=ie+1
            x=x+sco(ie,ij)
         enddo
c         print*,'x,xran,ie=',x,xran,ie
            
         prfois=.true.
         jch=0
         do while(jch.ne.maxcrep)
            print*,qn(ij,ie)
            essai=nul
            read(5,'(a)',end=888)essai
c            print*,'essai:',essai
c            print*,'rep  :',rep(ij,ie)
c            print*,'rep():',(rep(ij,ie)(i:i),i=1,maxcrep)

c     ---- opirations spiciales ----
            do while(essai(1:1).eq.'$'.or.essai(1:1).eq.'#')
               if(essai(1:1).eq.'$')then
                  do ie2=1,ne(ij)
                     write(6,'(i3,a1,f4.1,a2,a120)')
     _                    ie2,' ',sco(ie2,ij),'  ',rep(ij,ie2)
                  enddo
               elseif(essai(1:1).eq.'#')then
                  read(essai(2:maxcrep),*,err=444)ie2,sconew

                  call pgsci(0)
c     ==== extension 08/09/02 BEGIN
                  call pgsci(icolfond)
c     ==== extension 08/09/02 END

                  call pgsch(symch)
                  call pgpoint(1,ei(ie2),sco(ie2,ij),18)
                  call pgsch(1.8)
                  
                  sco(ie2,ij)=sconew
                  print*,ie2,rep(ij,ie2),sco(ie2,ij)
                  scomax=0.0    ! pour que les points sont renouveles
               endif
 444           continue
               print*,qn(ij,ie)
               essai=nul
               read(5,'(a)',end=888)essai
            enddo


            jch=0
            do ich=1,maxcrep
               ic=ich
               if(essai(ic:ic).eq.rep(ij,ie)(ich:ich))then
                  jch=jch+1
c               else
c                  write(6,'(i2,a,a,$)')
c     _                 ich,essai(ic:ic),rep(ij,ie)(ich:ich)
               endif
            enddo
c            print*,' '

            
            call pgsci(0)
c     ==== extension 08/09/02 BEGIN
            call pgsci(icolfond)
c     ==== extension 08/09/02 END

            call pgsch(symch)
            call pgpoint(1,ei(ie),sco(ie,ij),18)
            call pgsch(1.8)
            smax_anc= scomax
            if(prfois)then
               if(jch.eq.maxcrep)then
c                  print*,'Tres bien!'
                  print*,' '
                  if(sco(ie,ij).gt.2.0)then
                     sco(ie,ij)= sco(ie,ij)-1.0
                  else
                     sco(ie,ij)= sco(ie,ij)*0.8
                  endif
               else
                  if(jch.eq.maxcrep-1)then
                     sco(ie,ij)= sco(ie,ij)+1.0
                  elseif(jch.eq.maxcrep-2)then
                     sco(ie,ij)= sco(ie,ij)+2.0
                  elseif(jch.le.maxcrep-3)then
                     sco(ie,ij)= sco(ie,ij)+3.0
                  else
                     print*,'ERREUR: jch, maxcrep=',jch,maxcrep
                  endif
                  print*,'RP: ',rep(ij,ie)
               endif
            endif
            prfois=.false.
         enddo
c     ---- mettre la figure au jour ----

         scomax=0.0
         do ie2=1,ne(ij)
            scomax=max(scomax,sco(ie2,ij))
         enddo

         if(scomax.ne.smax_anc)then
            call pgsci(0)
c     ==== extension 08/09/02 BEGIN
            call pgsci(icolfond)
c     ==== extension 08/09/02 END

            call pgsch(symch)
            call pgpoint(ne(nj),ei,sco(1,ij),18)
            call pgsch(1.8)
         endif

         call pgsci(0)
c     ==== extension 08/09/02 BEGIN
         call pgsci(icolfond)
c     ==== extension 08/09/02 END
         call pgbox(' ',0.,0,'ntsv',0.,0)
         call pgsci(1)
c     ==== extension 08/09/02 BEGIN
         call pgsci(icol1)
c     ==== extension 08/09/02 END

         call pgwindow(xmin,xmax, ymin,ymax*scomax)         
         call pgbox(' ',0.,0,'ntsv',0.,0)
         call pgsci(icol1)
         call pgsch(symch)
         call pgpoint(ne(nj),ei,sco(1,ij),18)
         call pgsci(icol2)
         call pgpoint(1,ei(ie),sco(ie,ij),18)
         call pgsch(1.8)
         call pgsci(1)
c     ==== extension 08/09/02 BEGIN
         call pgsci(icol1)
c     ==== extension 08/09/02 END

      enddo
      
 888  continue
      call pgend

      scoN=0.0
      ntot=0
      do ij=1,nj
         do ie=1,ne(ij)
            scoN= scoN+ sco(ie,ij)
         enddo
         ntot= ntot+ ne(ij)
      enddo
      print*,'scoN=',scoN


      print*,'sco0, scoN, val0, ntot=',sco0,scoN,' ; ',val0, ntot

c     ---- nouveaux scores au fichier ----
      open(1,file='s0'//liste,access='sequential',status='unknown',
     _     form='unformatted')
      write(1)
     _     nj,(ne(ij),(sco(ie,ij),ie=1,ne(ij)),ij=1,nj)
            
      close(1)


      end




      integer*4  function iswbyte(i)
c     === swaps order of 4byte byte sequence ====
      integer*4  i
      integer*4  j,k
      byte       bylist1(4),bylist2(4)
      equivalence (bylist1,j),(bylist2,k)

      j=i
      bylist2(1)=bylist1(4)
      bylist2(2)=bylist1(3)
      bylist2(3)=bylist1(2)
      bylist2(4)=bylist1(1)
      
      iswbyte=k

      return
      end
 

      real*4 function ran4(iseed)
c     WARNING: This pseudo-random number generator should be sufficiently
c     good for educational software, since subtle correlations are not
c     a problem. However, it is unlikely to be good enough for 
c     detection of subtle statistical correlations in scientific
c     (physical or social) analysis.

      ip1=83
      ip2=29959 
      iseed=mod(iseed*ip1,ip2)
      ran4=real(iseed)/real(ip2)
      return
      end


      subroutine mypause
      character*1 ch
      print*,'Press the <enter> key to continue... '
      read(5,'(a)')ch
      return
      end

